import sys
import os
import subprocess
import shlex
from contextlib import suppress

here = os.path.dirname(os.path.abspath(__file__))

with open(os.path.join(here, "CURRENT_VERSION.txt")) as fh:
    for line in fh:
        if line.strip().startswith("#"):
            continue
        version = line.strip()
        break

current_sha = ""
if os.path.exists(os.path.join(here, ".git")):
    current_sha = subprocess.check_output(shlex.split("git rev-parse HEAD")).strip().decode()

full_version = version
if current_sha:
    full_version = f"{version}+git.{current_sha}"

with open(os.path.join(here, "instruct/about.py"), "w") as fh:
    fh.write(
        f"""# Autogenerated from `generate_version`
# it is run on setup.py/pip installs!

__version__ = "{full_version}"

"""
    )
